/*
* XMegaThread.c
*
* Created: 14.05.2017 13:24:36
* Author : Master
*/

#include <stddef.h>
#include <avr/io.h>
#include <util/delay.h>

#include "thread.h"

#define LED1_MASK 0x10
#define LED2_MASK 0x20

threadStatus_t led1(threadStatus_t state, void * argument) {

	PORTF.OUTCLR = LED1_MASK;
	_delay_ms(50.0);
	PORTF.OUTSET = LED1_MASK;
	return THREAD_STATUS_DEFAULT;
}

threadStatus_t led2(threadStatus_t state, void * argument) {
	PORTF.OUTCLR = LED2_MASK;
	_delay_ms(1500.0);
	PORTF.OUTSET = LED2_MASK;
	return THREAD_STATUS_DEFAULT;
}

int main(void) {
	PORTF.DIRSET = LED1_MASK|LED2_MASK;
	threadAdd(led1, NULL, 300 / THREAD_MS_PER_TICK);
	threadAdd(led2, NULL, 6000 / THREAD_MS_PER_TICK);
	threadStart();

	while (1) // idleLoop
	{
	}
}
