/*
* thread.h
*
* Created: 17.04.2017 12:45:50
* Author: Detlev Tietjen
* Licence: LGPL 3.0
*/


#ifndef THREAD_H_
#define THREAD_H_

#include <stdint.h>
#include <avr/io.h>

//defines the maximum number of threads
#define THREAD_MAX 16
#define THREAD_MS_PER_TICK 5
#define THREAD_STATUS_DEFAULT 1

struct		threadTCBData_t;
typedef		int8_t threadStatus_t;
typedef		struct threadTCBData_t * pThread_t;

typedef		threadStatus_t (*threadFunc_t)(threadStatus_t state, void * pArgument);

pThread_t	threadAdd(threadFunc_t f, void * argument, uint16_t periodTicks);
void		threadStart();

inline __attribute__((always_inline)) void threadBeginCriticalBlock()	{TCC1.INTCTRLA=0;}
inline __attribute__((always_inline)) void threadEndCriticalBlock()		{TCC1.INTCTRLA	= TC_OVFINTLVL_LO_gc;}
#define THREAD_CRITICAL_BLOCK			for(TCC1.INTCTRLA=0; 0==TCC1.INTCTRLA;TCC1.INTCTRLA	= TC_OVFINTLVL_LO_gc)
#define THREAD_NON_CRITICAL_BLOCK		for(TCC1.INTCTRLA=TC_OVFINTLVL_LO_gc; 0!=TCC1.INTCTRLA;TCC1.INTCTRLA = 0)
#endif /* THREAD_H_ */